/**
 * Javier Abelln. 3 Abril 2006
 * 
 * JComponent que tiene una imagen de fondo.
 */
package chuidiang.paneles;

import java.awt.Graphics;
import java.awt.Image;

import javax.swing.JComponent;

/**
 * JComponent con imagen de fondo.
 * @author Chuidiang
 *
 */
public class PanelImagenFondo extends JComponent
{
    /**
     * serial uid
     */
    private static final long serialVersionUID = 3546923588922718261L;

    /** Imagen que se va a usar de fondo */
    private Image imagen;
    
    /** Instancia esta clase, guardandose la imagen que se le pasa para que
     * sea la imagen de fondo.
     * @param imagen Imagen deseada para el fondo
     */
    public PanelImagenFondo (Image imagen)
    {
        this.imagen=imagen;
    }
    
    /** Redefinicin del mtodo paint(). Dibuja la imagen de fondo y luego
     * llama al mtodo padre con el mismo nombre.
     * @param g Graphics para dibujar
     */
    public void paint(Graphics g)
    {
        if (imagen != null)
            if (isEstirar())
                g.drawImage(imagen,posicionX,posicionY,getWidth(),getHeight(),this);
            else
                g.drawImage(imagen,posicionX,posicionY,this);
        super.paint(g);
    }
    
    /** Si se debe o no estirar la imagen para que ocupe todo el panel */
    private boolean estirar=true;
    
    /** Posicion x para la imagen */
    private int posicionX=0;
    
    /** Posicin y para la imagen */
    private int posicionY=0;

    /** Devuelve si se estira la imagen o no para ocupar todo el panel. */
    public boolean isEstirar()
    {
        return estirar;
    }

    /** Fija si se debe o no estirar la imagen a las dimensiones del panel */
    public void setEstirar(boolean estirar)
    {
        this.estirar = estirar;
    }

    /** Devuelve la posicin x donde se situa la imagen */
    public int getPosicionX()
    {
        return posicionX;
    }
    
    /** Fija la posicin x donde se situa la imagen */
    public void setPosicionX(int posicionX)
    {
        this.posicionX = posicionX;
    }

    /** Devuelve la posicin y donde se situa la imagen */
    public int getPosicionY()
    {
        return posicionY;
    }

    /** Fija la posicin y donde se situa la imagen */
    public void setPosicionY(int posicionY)
    {
        this.posicionY = posicionY;
    }
}
